=== debian/changelog ===
neovim (0.4.3-3) unstable; urgency=medium

  * Remove python-neovim from Recommends (Closes: #945709)
  * Add lintian override for desktop-command-not-in-package

 -- James McCoy <jamessan@debian.org>  Sat, 30 Nov 2019 22:58:51 -0500

neovim (0.4.3-2) unstable; urgency=medium

  * Backport "f_getenv/setenv: Access v_special when v_type is VAR_SPECIAL"
    from upstream to fix FTBFS on big-endian architectures.

 -- James McCoy <jamessan@debian.org>  Thu, 14 Nov 2019 22:55:58 -0500

neovim (0.4.3-1) unstable; urgency=medium

  * New upstream release
    + Fix crash when $CDPATH is invalid (Closes: #930079)
  * control:
    + neovim: Depend on lua-bitop when not built against LuaJIT
    + Build-Depend on lua-luv-dev (>= 1.30.1), per new upstream requirements
    + Add explicit lua-filesystem (>= 1.7) Build-Depends for tests
    + Build-Depend on libvterm-dev (>= 0.1), per new upstream requirements
    + Remove obsolete Breaks/Replaces from neovim-runtime
  * rules:
    + Explicitly use lua5.1/luajit to run functionaltest/unittest
    + Stop disabling jemalloc, since upstream no longer uses it
  * Declare compliance with Policy 4.4.1, no changes needed

 -- James McCoy <jamessan@debian.org>  Tue, 12 Nov 2019 22:35:34 -0500
